function dy = three_dof_arm_dyn_for_ODE(t,y)

y1 = y(1);
y2 = y(2);
y3 = y(3);
y4 = y(4);
y5 = y(5);
y6 = y(6);

L1=1;
L2=1;
L3=1;
M1=1;
M2=1;
M3=1;
g=9.8;

M =  [  L1^2*M1 + L1^2*M2 + L1^2*M3 + L2^2*M2 + L2^2*M3 + L3^2*M3 + 2*L1*L2*M2*cos(y3) + 2*L1*L2*M3*cos(y3) + 2*L2*L3*M3*cos(y5) + 2*L1*L3*M3*cos(y3 + y5), L2^2*M2 + L2^2*M3 + L3^2*M3 + L1*L2*M2*cos(y3) + L1*L2*M3*cos(y3) + 2*L2*L3*M3*cos(y5) + L1*L3*M3*cos(y3 + y5), L3*M3*(L3 + L1*cos(y3 + y5) + L2*cos(y5));
        L2^2*M2 + L2^2*M3 + L3^2*M3 + L1*L2*M2*cos(y3) + L1*L2*M3*cos(y3) + 2*L2*L3*M3*cos(y5) + L1*L3*M3*cos(y3 + y5),                                                               L2^2*M2 + L2^2*M3 + L3^2*M3 + 2*L2*L3*M3*cos(y5),                   L3*M3*(L3 + L2*cos(y5));
        L3*M3*(L3 + L1*cos(y3 + y5) + L2*cos(y5)),                                                                                        L3*M3*(L3 + L2*cos(y5)),                                   L3^2*M3];
 

F = -[   L2*M2*g*cos(y1 + y3) + L2*M3*g*cos(y1 + y3) + L1*M1*g*cos(y1) + L1*M2*g*cos(y1) + L1*M3*g*cos(y1) + L3*M3*g*cos(y1 + y3 + y5) - L1*L2*M2*y4^2*sin(y3) - L1*L2*M3*y4^2*sin(y3) - L2*L3*M3*y6^2*sin(y5) - L1*L3*M3*y4^2*sin(y3 + y5) - L1*L3*M3*y6^2*sin(y3 + y5) - 2*L1*L2*M2*y2*y4*sin(y3) - 2*L1*L2*M3*y2*y4*sin(y3) - 2*L2*L3*M3*y2*y6*sin(y5) - 2*L2*L3*M3*y4*y6*sin(y5) - 2*L1*L3*M3*y2*y4*sin(y3 + y5) - 2*L1*L3*M3*y2*y6*sin(y3 + y5) - 2*L1*L3*M3*y4*y6*sin(y3 + y5);
        L2*M2*g*cos(y1 + y3) + L2*M3*g*cos(y1 + y3) + L3*M3*g*cos(y1 + y3 + y5) + L1*L2*M2*y2^2*sin(y3) + L1*L2*M3*y2^2*sin(y3) - L2*L3*M3*y6^2*sin(y5) + L1*L3*M3*y2^2*sin(y3 + y5) - 2*L2*L3*M3*y2*y6*sin(y5) - 2*L2*L3*M3*y4*y6*sin(y5);
        L3*M3*g*cos(y1 + y3 + y5) + L2*L3*M3*y2^2*sin(y5) + L2*L3*M3*y4^2*sin(y5) + L1*L3*M3*y2^2*sin(y3 + y5) + 2*L2*L3*M3*y2*y4*sin(y5)];
 
N = eye(3,3);
N_half_inv = N;

K=20*eye(3,3);
Kd=2*eye(3,3);

% y_des=[t 0 -0.2*t]';
y_des=[0 0 -0.2]';
yd_des=[0 0 0]';
A=eye(3);
b=-K*( [y1 y3 y5]'-[y_des])-Kd*( [y2 y4 y6]'-[yd_des]);
% b=-K*( [y1 y3 y5]'-[y_des]);

M_inv = inv(M);
u= N_half_inv * pinv(A* M_inv * N_half_inv)*(b-A*M_inv*F);
    
% u=[-5*y(2) -1*y(4) -1*y(6)]';
% u=[0 0 0]';
dy = three_dof_arm_dyn(y,u);