function dy = two_dof_arm_dyn(y,u)

y1 = y(1);
y2 = y(2);
y3 = y(3);
y4 = y(4);
u1 = u(1);
u2 = u(2);

L1=1;
L2=1;
M1=1;
M2=1;
g=9.8;

dy1 = y2;
dy2 = (2*L2*u1 - 2*L2*u2 + sin(y3)*(2*L1*M2*L2^2*y2^2 + 4*L1*M2*L2^2*y2*y4 + 2*L1*M2*L2^2*y4^2) - 2*L1*u2*cos(y3) - 2*L1*L2*M1*g*cos(y1) - L1*L2*M2*g*cos(y1) + L1*L2*M2*g*cos(y1 + 2*y3) + L1^2*L2*M2*y2^2*sin(2*y3))/(L1^2*L2*(2*M1 + M2 - M2*cos(2*y3)));
dy3 = y4;
dy4 = -(L2^2*M2*u1 - L1^2*M2*u2 - L1^2*M1*u2 - L2^2*M2*u2 - L1*L2^2*M2^2*g*cos(y1) + L1^2*L2^2*M2^2*y2^2*sin(2*y3) + (L1^2*L2^2*M2^2*y4^2*sin(2*y3))/2 + L1*L2*M2*u1*cos(y3) - 2*L1*L2*M2*u2*cos(y3) + L1*L2^3*M2^2*y2^2*sin(y3) + L1^3*L2*M2^2*y2^2*sin(y3) + L1*L2^3*M2^2*y4^2*sin(y3) - L1*L2^2*M1*M2*g*cos(y1) - L1^2*L2*M2^2*g*sin(y1)*sin(y3) + L1*L2^2*M2^2*g*cos(y1)*cos(y3)^2 + L1^2*L2^2*M2^2*y2*y4*sin(2*y3) + L1^3*L2*M1*M2*y2^2*sin(y3) + 2*L1*L2^3*M2^2*y2*y4*sin(y3) - L1*L2^2*M2^2*g*cos(y3)*sin(y1)*sin(y3) - L1^2*L2*M1*M2*g*sin(y1)*sin(y3))/(L1^2*L2^2*M2*(M1 + M2 - M2*cos(y3)^2));

dy = [dy1 dy2 dy3 dy4]'; 